// GENERATED BY THE COMMAND ABOVE; DO NOT EDIT
// This file was generated by swaggo/swag

package docs

import (
	"bytes"
	"encoding/json"
	"strings"

	"github.com/alecthomas/template"
	"github.com/swaggo/swag"
)

var doc = `{
    "schemes": {{ marshal .Schemes }},
    "swagger": "2.0",
    "info": {
        "description": "{{.Description}}",
        "title": "{{.Title}}",
        "contact": {},
        "version": "{{.Version}}"
    },
    "host": "{{.Host}}",
    "basePath": "{{.BasePath}}",
    "paths": {
        "/api/v1/poc/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "列表",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "plugin list",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "Page",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "Pagesize",
                        "name": "pagesize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "affectsField",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "enableField",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "search",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "post": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "新增",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "plugin add",
                "parameters": [
                    {
                        "description": "plugin",
                        "name": "plugin",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/rule.Plugin"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/poc/download/": {
            "post": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "下载yaml",
                "tags": [
                    "Plugin"
                ],
                "summary": "download yaml",
                "parameters": [
                    {
                        "description": "json_poc",
                        "name": "run",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/plugin.DownloadSwigger"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/poc/run/": {
            "post": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "运行",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "plugin run",
                "parameters": [
                    {
                        "description": "run",
                        "name": "run",
                        "in": "body",
                        "schema": {
                            "$ref": "#/definitions/plugin.RunSwigger"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/poc/upload/": {
            "post": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "上传yaml",
                "consumes": [
                    "multipart/form-data",
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "upload yaml",
                "parameters": [
                    {
                        "type": "file",
                        "description": "file",
                        "name": "yaml",
                        "in": "formData",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/poc/{id}/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "详情",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "plugin detail",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "put": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "更新",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "plugin update",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "plugin",
                        "name": "plugin",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/rule.Plugin"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "delete": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "删除",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Plugin"
                ],
                "summary": "plugin delete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/product/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "列表",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Product"
                ],
                "summary": "product list",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "Page",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "Pagesize",
                        "name": "pagesize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "search",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "post": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "新增",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Product"
                ],
                "summary": "product add",
                "parameters": [
                    {
                        "description": "webapp",
                        "name": "plugin",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/db.Webapp"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/product/{id}/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "详情",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Product"
                ],
                "summary": "product detail",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "put": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "更新",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Product"
                ],
                "summary": "product update",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "webapp",
                        "name": "webapp",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/db.Webapp"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "delete": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "删除",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Product"
                ],
                "summary": "product delete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/result/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "列表",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Result"
                ],
                "summary": "result list",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "Page",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "Pagesize",
                        "name": "pagesize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "search",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "taskField",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "vulField",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/result/{id}/": {
            "delete": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "删除",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Result"
                ],
                "summary": "result delete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/scan/list": {
            "post": {
                "description": "传文件：url列表",
                "consumes": [
                    "multipart/form-data"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Scan"
                ],
                "summary": "scan list",
                "parameters": [
                    {
                        "type": "string",
                        "description": "扫描类型：multi / all",
                        "name": "type",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "array",
                        "items": {
                            "type": "string"
                        },
                        "name": "vul_list",
                        "in": "formData"
                    },
                    {
                        "type": "string",
                        "description": "备注",
                        "name": "remarks",
                        "in": "formData"
                    },
                    {
                        "type": "file",
                        "description": "file",
                        "name": "target",
                        "in": "formData",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/scan/raw": {
            "post": {
                "description": "传文件：请求报文",
                "consumes": [
                    "multipart/form-data",
                    "application/json"
                ],
                "tags": [
                    "Scan"
                ],
                "summary": "scan raw",
                "parameters": [
                    {
                        "type": "string",
                        "description": "扫描类型：multi / all",
                        "name": "type",
                        "in": "formData",
                        "required": true
                    },
                    {
                        "type": "array",
                        "items": {
                            "type": "string"
                        },
                        "name": "vul_list",
                        "in": "formData"
                    },
                    {
                        "type": "string",
                        "description": "备注",
                        "name": "remarks",
                        "in": "formData"
                    },
                    {
                        "type": "file",
                        "description": "file",
                        "name": "target",
                        "in": "formData",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/scan/url": {
            "post": {
                "description": "扫描单个url",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Scan"
                ],
                "summary": "scan url",
                "parameters": [
                    {
                        "description": "扫描参数",
                        "name": "scan",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/scan.scanSerializer"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/self/resetpwd/": {
            "post": {
                "description": "重置密码",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "User"
                ],
                "summary": "Reset Password",
                "parameters": [
                    {
                        "description": "旧/新密码",
                        "name": "resetpwd",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/auth.ResetPwd"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/task/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "列表",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Task"
                ],
                "summary": "task list",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "Page",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "Pagesize",
                        "name": "pagesize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "search",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/task/{id}/": {
            "delete": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "删除",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Task"
                ],
                "summary": "task delete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/user/info": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "获取个人信息",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "User"
                ],
                "summary": "Self",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/user/login": {
            "post": {
                "description": "登录",
                "consumes": [
                    "application/json"
                ],
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "User"
                ],
                "summary": "Login",
                "parameters": [
                    {
                        "description": "用户/密码",
                        "name": "auth",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/auth.Auth"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/user/logout": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "登出",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "User"
                ],
                "summary": "Logout",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/vul/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "列表",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Vul"
                ],
                "summary": "vul list",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "Page",
                        "name": "page",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "integer",
                        "description": "Pagesize",
                        "name": "pagesize",
                        "in": "query",
                        "required": true
                    },
                    {
                        "type": "string",
                        "name": "categoryField",
                        "in": "query"
                    },
                    {
                        "type": "string",
                        "name": "search",
                        "in": "query"
                    },
                    {
                        "type": "integer",
                        "name": "webappField",
                        "in": "query"
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "post": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "新增",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Vul"
                ],
                "summary": "vul add",
                "parameters": [
                    {
                        "description": "vul",
                        "name": "vul",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/vulnerability.SwagVulnerability"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/vul/basic/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "前端需要的基础信息",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Vul"
                ],
                "summary": "vul basic",
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        },
        "/api/v1/vul/{id}/": {
            "get": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "详情",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Vul"
                ],
                "summary": "vul detail",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "put": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "更新",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Vul"
                ],
                "summary": "vul update",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    },
                    {
                        "description": "vul",
                        "name": "vul",
                        "in": "body",
                        "required": true,
                        "schema": {
                            "$ref": "#/definitions/vulnerability.SwagVulnerability"
                        }
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            },
            "delete": {
                "security": [
                    {
                        "token": []
                    }
                ],
                "description": "删除",
                "produces": [
                    "application/json"
                ],
                "tags": [
                    "Vul"
                ],
                "summary": "vul delete",
                "parameters": [
                    {
                        "type": "integer",
                        "description": "ID",
                        "name": "id",
                        "in": "path",
                        "required": true
                    }
                ],
                "responses": {
                    "200": {
                        "description": "OK",
                        "schema": {
                            "$ref": "#/definitions/msg.Response"
                        }
                    }
                }
            }
        }
    },
    "definitions": {
        "auth.Auth": {
            "type": "object",
            "required": [
                "password",
                "username"
            ],
            "properties": {
                "password": {
                    "type": "string"
                },
                "username": {
                    "type": "string"
                }
            }
        },
        "auth.ResetPwd": {
            "type": "object",
            "required": [
                "newpassword",
                "password"
            ],
            "properties": {
                "newpassword": {
                    "type": "string"
                },
                "password": {
                    "type": "string"
                }
            }
        },
        "db.Webapp": {
            "type": "object",
            "required": [
                "name"
            ],
            "properties": {
                "id": {
                    "type": "integer"
                },
                "name": {
                    "type": "string"
                },
                "provider": {
                    "type": "string"
                },
                "remarks": {
                    "type": "string"
                }
            }
        },
        "msg.Response": {
            "type": "object",
            "properties": {
                "code": {
                    "type": "integer"
                },
                "data": {
                    "type": "object"
                },
                "error": {
                    "type": "string"
                }
            }
        },
        "plugin.DownloadSwigger": {
            "type": "object",
            "properties": {
                "json_poc": {
                    "$ref": "#/definitions/rule.Plugin"
                }
            }
        },
        "plugin.RunSwigger": {
            "type": "object",
            "properties": {
                "affects": {
                    "type": "string"
                },
                "json_poc": {
                    "$ref": "#/definitions/rule.Plugin"
                },
                "target": {
                    "type": "string"
                },
                "vul_id": {
                    "type": "string"
                }
            }
        },
        "rule.Detail": {
            "type": "object",
            "properties": {
                "author": {
                    "type": "string"
                },
                "description": {
                    "type": "string"
                },
                "links": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "version": {
                    "type": "string"
                }
            }
        },
        "rule.Plugin": {
            "type": "object",
            "properties": {
                "affects": {
                    "description": "影响类型  dir/server/param/url/content",
                    "type": "string"
                },
                "enable": {
                    "description": "是否启用",
                    "type": "boolean"
                },
                "jsonPoc": {
                    "description": "json规则",
                    "$ref": "#/definitions/rule.Poc"
                },
                "vulId": {
                    "description": "漏洞编号",
                    "type": "string"
                }
            }
        },
        "rule.Poc": {
            "type": "object",
            "properties": {
                "detail": {
                    "$ref": "#/definitions/rule.Detail"
                },
                "groups": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "array",
                        "items": {
                            "$ref": "#/definitions/rule.Rule"
                        }
                    }
                },
                "name": {
                    "type": "string"
                },
                "params": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                },
                "rules": {
                    "type": "array",
                    "items": {
                        "$ref": "#/definitions/rule.Rule"
                    }
                },
                "set": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "string"
                    }
                }
            }
        },
        "rule.Rule": {
            "type": "object",
            "properties": {
                "body": {
                    "type": "string"
                },
                "expression": {
                    "type": "string"
                },
                "follow_redirects": {
                    "type": "boolean"
                },
                "headers": {
                    "type": "object",
                    "additionalProperties": {
                        "type": "string"
                    }
                },
                "method": {
                    "type": "string"
                },
                "path": {
                    "type": "string"
                },
                "search": {
                    "type": "string"
                }
            }
        },
        "scan.scanSerializer": {
            "type": "object",
            "required": [
                "target",
                "type"
            ],
            "properties": {
                "remarks": {
                    "type": "string"
                },
                "target": {
                    "description": "单个url",
                    "type": "string"
                },
                "type": {
                    "description": "multi or all",
                    "type": "string"
                },
                "vul_list": {
                    "type": "array",
                    "items": {
                        "type": "string"
                    }
                }
            }
        },
        "vulnerability.SwagVulnerability": {
            "type": "object",
            "required": [
                "name_zh"
            ],
            "properties": {
                "category": {
                    "type": "string"
                },
                "cnnvd": {
                    "type": "string"
                },
                "cve": {
                    "type": "string"
                },
                "description": {
                    "type": "string"
                },
                "foreignWebapp": {
                    "$ref": "#/definitions/db.Webapp"
                },
                "id": {
                    "type": "integer"
                },
                "language": {
                    "type": "string"
                },
                "name_zh": {
                    "type": "string"
                },
                "severity": {
                    "type": "string"
                },
                "suggestion": {
                    "type": "string"
                },
                "webapp": {
                    "type": "integer"
                }
            }
        }
    },
    "securityDefinitions": {
        "token": {
            "type": "apiKey",
            "name": "Authorization",
            "in": "header"
        }
    }
}`

type swaggerInfo struct {
	Version     string
	Host        string
	BasePath    string
	Schemes     []string
	Title       string
	Description string
}

// SwaggerInfo holds exported Swagger Info so clients can modify it
var SwaggerInfo = swaggerInfo{
	Version:     "v0.4.0",
	Host:        "",
	BasePath:    "",
	Schemes:     []string{},
	Title:       "Pocassist Api",
	Description: "Pocassist Api",
}

type s struct{}

func (s *s) ReadDoc() string {
	sInfo := SwaggerInfo
	sInfo.Description = strings.Replace(sInfo.Description, "\n", "\\n", -1)

	t, err := template.New("swagger_info").Funcs(template.FuncMap{
		"marshal": func(v interface{}) string {
			a, _ := json.Marshal(v)
			return string(a)
		},
	}).Parse(doc)
	if err != nil {
		return doc
	}

	var tpl bytes.Buffer
	if err := t.Execute(&tpl, sInfo); err != nil {
		return doc
	}

	return tpl.String()
}

func init() {
	swag.Register(swag.Name, &s{})
}
